/*
****************************************************************************************************
*                                             DUCP HOST
*                      			Displayer universal control protocal for host
*                                      	   Master Head File
*
*                          			(c) Copyright 2016-2017, KF 
*                                        All Rights Reserved
*
* File : DUCP_Host.h
* By   : Lyon 
* Date : 2016-1-1
* Email: yangzhonglai@163.com
****************************************************************************************************
*/
#ifndef _DUCP_DEVICE_H_
#define _DUCP_DEVICE_H_

#include "MBmsg.h"
#include "DUCP.H"

//  ifdef Ǵʹ DLL 򵥵
// ı׼ DLL еļ϶ DUCP_EXPORTS
// űġʹô DLL 
// κĿϲӦ˷šԴļаļκĿὫ
// DUCP_API ΪǴ DLL ģ DLL ô˺궨
// ΪǱġ
#ifdef DUCP_EXPORTS
#define DUCP_API __declspec(dllexport)
#else
#define DUCP_API __declspec(dllimport)
#endif


#if defined(__cplusplus)
extern "C" {     /* Make sure we have C-declarations in C++ programs */
#endif


/*
¼DUCP
*/
EXTERN_C DUCP_API DUCP_ERR_T	DUCP_HOST_SYS_Connet(const char * Password);

/*
ͬ
*/
EXTERN_C DUCP_API DUCP_ERR_T	DUCP_HOST_SYS_SYNPN(int PN);

/*
ĵ¼
*/
EXTERN_C DUCP_API DUCP_ERR_T	DUCP_HOST_SYS_SetPassword(const char * Password);

/*
ȡ¼
*/
EXTERN_C DUCP_API DUCP_ERR_T	DUCP_HOST_SYS_GetPassword(char * Password);

/*
ȡ̼Ϣ
*/
EXTERN_C DUCP_API DUCP_ERR_T	DUCP_HOST_SYS_GetFirmware(DEVICE_FRAMWARE_T * pFirmware);

/*
±ʱ
*/
EXTERN_C DUCP_API DUCP_ERR_T	DUCP_HOST_SYS_UpdateTime(uint16_t Year,
									uint8_t Month,
									uint8_t Day,
									uint8_t Week,
									uint8_t Hour,
									uint8_t Minute,
									uint8_t Second);

/*
õַ
*/
EXTERN_C DUCP_API DUCP_ERR_T	DUCP_HOST_SYS_SetAddr(uint8_t Addr);

/*
IPַ
*/
EXTERN_C DUCP_API DUCP_ERR_T	DUCP_HOST_SYS_SetIP(const char * IP);
/*
ö˿
*/
EXTERN_C DUCP_API DUCP_ERR_T	DUCP_HOST_SYS_SetPort(uint32_t Port);

/*
ò
*/
EXTERN_C DUCP_API DUCP_ERR_T	DUCP_HOST_SYS_SetBaud(uint32_t Baud);

/*
ɨƵ
*/
EXTERN_C DUCP_API DUCP_ERR_T	DUCP_HOST_SYS_SetScanFre(uint16_t Fre);

/*

*/
EXTERN_C DUCP_API DUCP_ERR_T	DUCP_HOST_SYS_SetLight(uint8_t Light);

/*

*/
EXTERN_C DUCP_API DUCP_ERR_T	DUCP_HOST_SYS_SetVol(uint8_t Vol);

/*
ϵͳ
*/
EXTERN_C DUCP_API DUCP_ERR_T	DUCP_HOST_SYS_Reset(void);

/*
	IOڹ
*/
EXTERN_C DUCP_API DUCP_ERR_T	DUCP_HOST_SYS_CfgIO(IO_PIN_ID_E Pin,IO_PIN_FUN_E Fun);

/*
	IO״̬
*/
EXTERN_C DUCP_API DUCP_ERR_T	DUCP_HOST_SYS_SetOutState(IO_PIN_ID_E Pin,int OnOff);

/*
	ȡIO״̬
*/
EXTERN_C DUCP_API DUCP_ERR_T	DUCP_HOST_SYS_ReadInputState(IO_PIN_ID_E Pin,int * pRetState);

/*
	LED
*/
EXTERN_C DUCP_API DUCP_ERR_T	DUCP_HOST_SYS_SetDrv(int v);

/*
	OE
*/
EXTERN_C DUCP_API DUCP_ERR_T	DUCP_HOST_SYS_SetOEPolarity(int v);

/*
	ݼ
*/
EXTERN_C DUCP_API DUCP_ERR_T	DUCP_HOST_SYS_SetDataPolarity(int v);

/*
	LEźʱ
*/
EXTERN_C DUCP_API DUCP_ERR_T	DUCP_HOST_SYS_SetLEDelay(int En);

/*
	غ
*/
EXTERN_C DUCP_API DUCP_ERR_T	DUCP_HOST_SYS_SetGWAndMask(const char * GW,const char * Mask);

/*
	밲ȫģʽ
*/
EXTERN_C DUCP_API DUCP_ERR_T	DUCP_HOST_SYS_EnterSafMode(const char * pswd);

/*
	֤
	
	Msg: Ϣַ
	MsgLen: Ϣȣ255ֽ,255ֻǰ255ֽڡ
	pOutResult:ص32λ
*/
EXTERN_C DUCP_API DUCP_ERR_T	DUCP_HOST_SYS_Clic(const char * Msg,int MsgLen,int * pOutResult);

/*
	ʾߴ
*/
EXTERN_C DUCP_API DUCP_ERR_T	DUCP_HOST_SYS_SetDisSize(int XSize,int YSize);

/*
	ʾ
*/
EXTERN_C DUCP_API DUCP_ERR_T	DUCP_HOST_SYS_SetXYMIR(int Flag);

/*
	485ģʽ
*/
EXTERN_C DUCP_API DUCP_ERR_T	DUCP_HOST_SYS_Set485Mode(int ModeIndex);

/*
	ȡв
*/
EXTERN_C DUCP_API DUCP_ERR_T	DUCP_HOST_SYS_GetAll(SysSettings_t * pSet);

/*
	в
*/
EXTERN_C DUCP_API DUCP_ERR_T	DUCP_HOST_SYS_SetAll(SysSettings_t * pSet);

/*
	ʹTTS(ҪⲿTTSӲģ)
*/
EXTERN_C DUCP_API DUCP_ERR_T	DUCP_HOST_SYS_TTSEn(int Enable);

/*
	Ŀ¼
*/
EXTERN_C DUCP_API DUCP_ERR_T	DUCP_HOST_FM_Mount(const char * Path);

/*
	ļ
*/
EXTERN_C DUCP_API DUCP_ERR_T	DUCP_HOST_FM_Open(const char * Path,int Opt);

/*
	ļĶдλ
*/
EXTERN_C DUCP_API DUCP_ERR_T	DUCP_HOST_FM_Seek(int Offset);

/*
	дļ
*/
EXTERN_C DUCP_API DUCP_ERR_T	DUCP_HOST_FM_Write(const uint8_t * pData,uint32_t Size);

/*
	ļ
*/
EXTERN_C DUCP_API DUCP_ERR_T	DUCP_HOST_FM_Read(uint8_t * pData,uint32_t Size,uint32_t * pRetSize);

/*
	ͬļ
*/
EXTERN_C DUCP_API DUCP_ERR_T	DUCP_HOST_FM_SynBuff(void);

/*
	رյǰļ
*/
EXTERN_C DUCP_API DUCP_ERR_T	DUCP_HOST_FM_Close(void);

/*
	ɾǰļ
*/
EXTERN_C DUCP_API DUCP_ERR_T	DUCP_HOST_FM_Del(const char * Path);

/*
	ļ
*/
EXTERN_C DUCP_API DUCP_ERR_T	DUCP_HOST_FM_Copy(const char * DesPath,const char * SrcPath,int Opt);

/*
	ʽ
*/
EXTERN_C DUCP_API DUCP_ERR_T	DUCP_HOST_FM_FDisk(void);

/*

*/
EXTERN_C DUCP_API DUCP_ERR_T	DUCP_HOST_TTS_Play(const char * pText, uint8_t Opt);

/*
ֹͣ
*/
EXTERN_C DUCP_API DUCP_ERR_T	DUCP_HOST_TTS_Stop(void);

/*
Ƶ
*/
EXTERN_C DUCP_API DUCP_ERR_T	DUCP_HOST_2D_DrawPoint(int x0, int y0);

/*

*/
EXTERN_C DUCP_API DUCP_ERR_T	DUCP_HOST_2D_DrawLine(int x0, int y0, int x1, int y1);

/*
ƾ
*/
EXTERN_C DUCP_API DUCP_ERR_T	DUCP_HOST_2D_DrawRect(int x0, int y0, int x1, int y1);

/*

*/
EXTERN_C DUCP_API DUCP_ERR_T	DUCP_HOST_2D_FillRect(int x0, int y0, int x1, int y1);

/*
Բ
*/
EXTERN_C DUCP_API DUCP_ERR_T	DUCP_HOST_2D_DrawCircle(int x0, int y0, int r);

/*
Բ
*/
EXTERN_C DUCP_API DUCP_ERR_T	DUCP_HOST_2D_FillCircle(int x0, int y0, int r);

/*
λͼ
*/
EXTERN_C DUCP_API DUCP_ERR_T	DUCP_HOST_2D_DrawBitmap(int x0, int y0, int xSize, int ySize,
									int BitsPerPixle, int BytesPerLine,
									int DataSize, int ColorTabelSize,
									const uint8_t * pData);

/*
ʾı
*/
EXTERN_C DUCP_API DUCP_ERR_T	DUCP_HOST_2D_DisText(int x0, int y0, const char * pText);

/*
ûͼɫ
*/
EXTERN_C DUCP_API DUCP_ERR_T	DUCP_HOST_2D_SetColor(int Color);

/*
ñɫ
*/
EXTERN_C DUCP_API DUCP_ERR_T	DUCP_HOST_2D_SetBkColor(int Color);

/*

*/
EXTERN_C DUCP_API DUCP_ERR_T	DUCP_HOST_2D_SetFont(int FontIndex);

/*
ϵͳԴλͼ
*/
EXTERN_C DUCP_API DUCP_ERR_T	DUCP_HOST_2D_DrawSysIcon(int x0, int y0, int Num,int Denom,int IconIndex);

/*
ʾд
*/
EXTERN_C DUCP_API DUCP_ERR_T	DUCP_HOST_WM_ShowWindow(int WinID);

/*
д
*/
EXTERN_C DUCP_API DUCP_ERR_T	DUCP_HOST_WM_HideWindow(int WinID);

/*
ɾд
*/
EXTERN_C DUCP_API DUCP_ERR_T	DUCP_HOST_WM_DelWindow(int WinID);

/*
	ôԶͬʾ
*/
EXTERN_C DUCP_API DUCP_ERR_T	DUCP_HOST_WM_AutoSyn(int En);


/*
ıؼ
*/
EXTERN_C DUCP_API DUCP_ERR_T DUCP_HOST_TWIN_Create(int WinID, int Stile, int x0, int y0, int xSize, int ySize);

/*
ɾıؼ
*/
EXTERN_C DUCP_API DUCP_ERR_T DUCP_HOST_TWIN_Del(int WinID);


/*
ıؼʾıӿصֵܱ档Ƽʹӿʾĵݡ
*/
EXTERN_C DUCP_API DUCP_ERR_T DUCP_HOST_TWIN_DisText(	int WinID,
									const char * pText,
									int EnterMode,
									int EnterSpeed,
									int DelayMode,
									int DelayTime,
									int EixtMode,
									int EixtSpeed,
									int FontIndex,
									int TextColor,
									int BkColor,
									int DisTimes);

/*
ıؼ
*/
EXTERN_C DUCP_API DUCP_ERR_T DUCP_HOST_TWIN_SetFont(int WinID, int FontIndex);

/*
ıؼıɫ
*/
EXTERN_C DUCP_API DUCP_ERR_T DUCP_HOST_TWIN_SetTextColor(int WinID, int Color);

/*
ıؼıɫ
*/
EXTERN_C DUCP_API DUCP_ERR_T DUCP_HOST_TWIN_SetBkColor(int WinID, int Color);

/*
ֹͣʾıؼ
*/
EXTERN_C DUCP_API DUCP_ERR_T DUCP_HOST_TWIN_StopDis(int WinID);

/*
ıļıؼӿصֻᱣڴУᱣ档
ƵʹӿڣԽFLASHʹ
ԲĵصС ȡ
*/
EXTERN_C DUCP_API DUCP_ERR_T DUCP_HOST_TWIN_DownTextFile(	int WinID,
										int FileID,
										const char * pText,
										int EnterMode,
										int EnterSpeed,
										int DelayMode,
										int DelayTime,
										int EixtMode,
										int EixtSpeed,
										int FontIndex,
										int TextColor,
										int BkColor);
/*
ʾıؼıļ
*/
EXTERN_C DUCP_API DUCP_ERR_T DUCP_HOST_TWIN_DisFile(int WinID, int FileID);

/*
ıؼıļ
*/
EXTERN_C DUCP_API DUCP_ERR_T DUCP_HOST_TWIN_OpenFile(int WinID, int FileID);

/*
رıؼıļ
*/
EXTERN_C DUCP_API DUCP_ERR_T DUCP_HOST_TWIN_CloseFile(int WinID, int FileID);

/*
ɾıؼıļ
*/
EXTERN_C DUCP_API DUCP_ERR_T DUCP_HOST_TWIN_DelFile(int WinID, int FileID);

/*
	ͬʾıؼ
*/
EXTERN_C DUCP_API DUCP_ERR_T DUCP_HOST_TWIN_SynDis(char * pList,int NumBytes);

/*
	ʾҲ
*/
EXTERN_C DUCP_API DUCP_ERR_T DUCP_HOST_TWIN_SYN_DisEx(	int StartWinID,
													const char * pText,
													int EnterMode,
													int EnterSpeed,
													int DelayMode,
													int DelayTime,
													int EixtMode,
													int EixtSpeed,
													int FontIndex,
													int TextColor,
													int BkColor,
													int DisTimes,
													const char * pVoice);

/*
ͼƬؼ
*/
EXTERN_C DUCP_API DUCP_ERR_T DUCP_HOST_PIC_Create(int WinID,int x0, int y0, int xSize, int ySize);

/*
ɾͼƬؼ
*/
EXTERN_C DUCP_API DUCP_ERR_T DUCP_HOST_PIC_Del(int WinID);

/*
ͼƬؼ׷ͼƬ
*/
EXTERN_C DUCP_API DUCP_ERR_T DUCP_HOST_PIC_Add(int WinID,int FID,uint8_t EnterMode,uint8_t EnterSpeed,
							uint8_t StopMode,uint8_t StopTime,uint8_t ExitMode,uint8_t ExitSpeed);

/*
ɾͼƬ
*/
EXTERN_C DUCP_API DUCP_ERR_T DUCP_HOST_PIC_Clr(int WinID);

#if defined(__cplusplus)
}
#endif

#endif


