
#ifndef _MBMSG_H_
#define _MBMSG_H_

#include <stdint.h>

#if defined(__cplusplus)
extern "C" {     /* Make sure we have C-declarations in C++ programs */
#endif

#define MB_STK_ADDR_DEF		(0x00)	/*Ĭϵĵַ*/
#define MB_STK_FC_DEF		(100)	/*ĬϵĹ*/


#define MB_MSG_SIZE_MAX		(255)

/*
	Ϣṹ
*/
typedef struct {
	uint8_t 	PN[2];
	uint8_t  	MsgId;
	uint8_t 	DLen;
	uint8_t  	Data[MB_MSG_SIZE_MAX];
} MB_MSG_T;

/*
	Ϣɻص
*/
typedef int8_t (*cbMsgRdy_t)(MB_MSG_T *);

typedef int8_t (*cbSTKOut_t)(uint8_t * p,uint32_t size);

/*
    CRC16У麯
*/
uint16_t MB_CRC16(uint8_t *pFrame, uint16_t count);

/*
	Эص
*/
void MB_STK_SetOutCallback(cbSTKOut_t cb);

/*
	Эջ
*/
int8_t MB_STK_In(uint8_t * pBuff,uint16_t Size);
/*
	õַ
*/
uint8_t MB_STK_SetAddr(uint8_t NewAddr);

/*
	Ϣص
*/
void MB_MSG_SetMsgRdyCallback(cbMsgRdy_t cb);


/*
	Ϣ
	PN + MSGID + DLEN + DATA
*/
int8_t MB_MSG_Send(MB_MSG_T * pMsg,uint32_t Ovtime);

/*
	Ϣ
	PN + MSGID + DLEN + DATA
*/
int8_t MB_MSG_Read(MB_MSG_T * pMsg,uint32_t Ovtime);

/*
	Ϣ
	PN + MSGID + DLEN + DATA
*/
MB_MSG_T * MB_MSG_ReadEx(uint32_t Ovtime);

#if defined(__cplusplus)
}
#endif

#endif

